    module Handler.Manager where


import Import
import Data.Text (unpack)

import Yesod.Core.Types (FileInfo (..))
import Yesod.Form.Bootstrap3 (BootstrapFormLayout (..), renderBootstrap3, withSmallInput)
import Lib (splitStrings)
import UniversityMemberWrapper (parseMembers)
import Data.ByteString.Char8 (unpack)

getLines = liftM lines . readFile

getImportMembersR :: Handler Html
getImportMembersR = do
    (formWidget, formEnctype) <- generateFormPost sampleForm
    defaultLayout $ do
        setTitle "Welcome To Yesod!"
        $(widgetFile "homepage")

postImportMembersR :: Handler ()
postImportMembersR = do

    ((result, _), _) <- runFormPost sampleForm 
    
    
    let handlerName = "ImportMembersR" :: Text
    case result of
        FormSuccess (fi, _) -> do
            let fn = "/home/josias/yesod/Haskell_Yesod_LP/static/" ++ (Data.Text.unpack $ fileName fi)
            master <- try (getLines fn) :: Handler (Either IOException [String])
            
            case master of
                Right [] -> do
                    setMessageI MsgFileFormError
                    redirect $ ImportMembersR
                Right ss -> do
                    let sss = splitStrings ss []
                    let ms = parseMembers sss
                    _ <- saveMembersToDatabase ms
                    if length ms == 0
                        then
                            redirect $ UndergraduatesR
                        else
                            redirect $ TeacherUGStudentsR
                Left _ -> do
                    redirect $ TeachersR
                
--             if length ms > 0
--                 then
--                 else
--                     redirect $ TeachersR
        _ -> do
            setMessageI MsgFileFormError
            redirect $ ImportMembersR



sampleForm :: Form (FileInfo, Text)
sampleForm = renderBootstrap3 BootstrapBasicForm $ (,)
    <$> fileAFormReq "Choose a file"
    <*> pure ""

saveMembersToDatabase :: [UniversityMember] -> Handler Int
saveMembersToDatabase [] = return 0
saveMembersToDatabase (m:ms) = do
    _ <- case m of
            UGSMember um -> do
                _ <- runDB $ insert um
                return ()
            GSMember um -> do
                _ <- runDB $ insert um
                return ()
            TMember um -> do
                _ <- runDB $ insert um
                return ()
            TUGSMember um -> do
                _ <- runDB $ insert um
                return ()
            TGSMember um -> do
                _ <- runDB $ insert um
                return ()
            CSMember um -> do
                _ <- runDB $ insert um
                return ()
            SUGSMember um -> do
                _ <- runDB $ insert um
                return ()
            SGSMember um -> do
                _ <- runDB $ insert um
                return ()

    n <- saveMembersToDatabase ms

    return $ 1 + n
    
    