module Handler.ServantGStudent where

import Import
import UniversityMembersForms (servantGStudentForm)

getServantGStudentsR :: Handler Html
getServantGStudentsR = do
    mmsg <- getMessage
    servantGStudents <- runDB $ selectList [] [Asc ServantGStudentId]
    defaultLayout $ do
        setTitle "ServantGStudents"
        $(widgetFile "servantGStudent/all")


getNewServantGStudentR :: Handler Html
getNewServantGStudentR = do
    mmsg <- getMessage
    let memberType = "ServantGStudents" :: Text
        route = ServantGStudentsR
    (formWidget, enctype) <- generateFormPost $ servantGStudentForm Nothing

    defaultLayout $ do
        setTitle "New ServantGStudent"
        $(widgetFile "member/new")    

postNewServantGStudentR :: Handler ()
postNewServantGStudentR = do

    ((res, _), _) <- runFormPost $ servantGStudentForm Nothing

    case res of
        FormSuccess newSGS -> do
            mid <- runDB $ getBy $ UniqueSGSReg (servantGStudentRegE newSGS) (servantGStudentRegS newSGS)
            case mid of
                Nothing -> do
                    _ <- runDB $ insert newSGS
                    setMessageI MsgMemberSaved
                    redirect $ ServantGStudentsR
                _ -> do
                    setMessageI MsgDuplicatedMemberError
                    redirect $ NewServantGStudentR
        _ -> do
            setMessageI MsgNewMemberError
            redirect $ NewServantGStudentR

getEditServantGStudentR :: ServantGStudentId -> Handler Html
getEditServantGStudentR ssid = do
    (mmsg) <- getMessage
    let memberType = "ServantGStudents" :: Text
        route = ServantGStudentsR
    -- get the servantGStudent by id
    servantGStudent <- runDB $ selectFirst [ServantGStudentId ==. ssid] []

    (formWidget, enctype) <- generateFormPost $ servantGStudentForm $ fmap entityVal servantGStudent

    defaultLayout $ do
        setTitle "Edit ServantGStudent"
        $(widgetFile "member/edit")

postEditServantGStudentR :: ServantGStudentId -> Handler ()
postEditServantGStudentR ssid = do
    -- get the servantGStudent by id
    servantGStudent <- runDB $ get404 ssid

    ((res,_), _) <- runFormPost $ servantGStudentForm $ Just servantGStudent

    case res of
        FormSuccess updateSGS -> do
            mdup <- runDB $ getBy $ UniqueSGSReg (servantGStudentRegE updateSGS) (servantGStudentRegS updateSGS)
            case fmap entityKey mdup of
                Just _ -> do
                    setMessageI MsgDuplicatedMemberError
                    redirect $ EditServantGStudentR ssid
                Nothing -> do
                    _ <- runDB $ replace ssid $ updateSGS
                    setMessageI MsgMemberSaved
            redirect $ ServantGStudentsR
        _ -> do
            setMessageI MsgNewMemberError
            redirect $ NewServantGStudentR
