module Handler.ServantUGStudent where

import Import
import UniversityMembersForms (servantUGStudentForm)

getServantUGStudentsR :: Handler Html
getServantUGStudentsR = do
    mmsg <- getMessage
    servantUGStudents <- runDB $ selectList [] [Asc ServantUGStudentId]
    defaultLayout $ do
        setTitle "ServantUGStudents"
        $(widgetFile "servantUGStudent/all")


getNewServantUGStudentR :: Handler Html
getNewServantUGStudentR = do
    mmsg <- getMessage
    let memberType = "ServantUGStudents" :: Text
        route = ServantUGStudentsR
    (formWidget, enctype) <- generateFormPost $ servantUGStudentForm Nothing

    defaultLayout $ do
        setTitle "New ServantUGStudent"
        $(widgetFile "member/new")    

postNewServantUGStudentR :: Handler ()
postNewServantUGStudentR = do

    ((res, _), _) <- runFormPost $ servantUGStudentForm Nothing

    case res of
        FormSuccess newSUGS -> do
            mid <- runDB $ getBy $ UniqueSUGSReg (servantUGStudentRegE newSUGS) (servantUGStudentRegS newSUGS)
            case mid of
                Nothing -> do
                    _ <- runDB $ insert newSUGS
                    setMessageI MsgMemberSaved
                    redirect $ ServantUGStudentsR
                _ -> do
                    setMessageI MsgDuplicatedMemberError
                    redirect $ NewServantUGStudentR
        _ -> do
            setMessageI MsgNewMemberError
            redirect $ NewServantUGStudentR

getEditServantUGStudentR :: ServantUGStudentId -> Handler Html
getEditServantUGStudentR ssid = do
    (mmsg) <- getMessage
    let memberType = "ServantUGStudents" :: Text
        route = ServantUGStudentsR
    -- get the servantUGStudent by id
    servantUGStudent <- runDB $ selectFirst [ServantUGStudentId ==. ssid] []

    (formWidget, enctype) <- generateFormPost $ servantUGStudentForm $ fmap entityVal servantUGStudent

    defaultLayout $ do
        setTitle "Edit ServantUGStudent"
        $(widgetFile "member/edit")

postEditServantUGStudentR :: ServantUGStudentId -> Handler ()
postEditServantUGStudentR ssid = do
    -- get the servantUGStudent by id
    servantUGStudent <- runDB $ get404 ssid

    ((res,_), _) <- runFormPost $ servantUGStudentForm $ Just servantUGStudent

    case res of
        FormSuccess updateSUGS -> do
            mdup <- runDB $ getBy $ UniqueSUGSReg (servantUGStudentRegE updateSUGS) (servantUGStudentRegS updateSUGS)
            case fmap entityKey mdup of
                Just _ -> do
                    setMessageI MsgDuplicatedMemberError
                    redirect $ EditServantUGStudentR ssid
                Nothing -> do
                    _ <- runDB $ replace ssid $ updateSUGS
                    setMessageI MsgMemberSaved
            redirect $ ServantUGStudentsR
        _ -> do
            setMessageI MsgNewMemberError
            redirect $ NewServantUGStudentR
