module Handler.TeacherGStudent where

import Import
import UniversityMembersForms (teacherGStudentForm)
import Employee (showRegime)

getTeacherGStudentsR :: Handler Html
getTeacherGStudentsR = do
    mmsg <- getMessage

    teacherGStudents <- runDB $ selectList [] [Asc TeacherGStudentId]
    defaultLayout $ do
        setTitle "TeacherGStudents"
        $(widgetFile "teacherGStudent/all")


getNewTeacherGStudentR :: Handler Html
getNewTeacherGStudentR = do
    mmsg <- getMessage

    let memberType = "TeacherGStudents" :: Text
        route = TeacherGStudentsR

    (formWidget, enctype) <- generateFormPost $ teacherGStudentForm Nothing

    defaultLayout $ do
        setTitle "New TeacherGStudent"
        $(widgetFile "member/new")    

postNewTeacherGStudentR :: Handler ()
postNewTeacherGStudentR = do

    ((res, _), _) <- runFormPost $ teacherGStudentForm Nothing

    case res of
        FormSuccess newTGS -> do
            mid <- runDB $ getBy $ UniqueTGSReg (teacherGStudentRegE newTGS) (teacherGStudentRegS newTGS)
            case mid of
                Nothing -> do
                    _ <- runDB $ insert newTGS
                    setMessageI MsgMemberSaved
                    redirect $ TeacherGStudentsR
                _ -> do
                    setMessageI MsgDuplicatedMemberError
                    redirect $ NewTeacherGStudentR
        _ -> do
            setMessageI MsgNewMemberError
            redirect $ NewTeacherGStudentR

getEditTeacherGStudentR :: TeacherGStudentId -> Handler Html
getEditTeacherGStudentR tsid = do
    (mmsg) <- getMessage
    let memberType = "TeacherGStudents" :: Text
        route = TeacherGStudentsR
    -- get the teacherGStudent by id
    teacherGStudent <- runDB $ selectFirst [TeacherGStudentId ==. tsid] []

    (formWidget, enctype) <- generateFormPost $ teacherGStudentForm $ fmap entityVal teacherGStudent

    defaultLayout $ do
        setTitle "Edit TeacherGStudent"
        $(widgetFile "member/edit")

postEditTeacherGStudentR :: TeacherGStudentId -> Handler ()
postEditTeacherGStudentR tsid = do
    -- get the teacherGStudent by id
    teacherGStudent <- runDB $ get404 tsid

    ((res,_), _) <- runFormPost $ teacherGStudentForm $ Just teacherGStudent

    case res of
        FormSuccess updateTGS -> do
            mdup <- runDB $ getBy $ UniqueTGSReg (teacherGStudentRegE updateTGS) (teacherGStudentRegS updateTGS)
            case fmap entityKey mdup of
                Just _ -> do
                    setMessageI MsgDuplicatedMemberError
                    redirect $ EditTeacherGStudentR tsid
                Nothing -> do
                    _ <- runDB $ replace tsid $ updateTGS
                    setMessageI MsgMemberSaved
            redirect $ TeacherGStudentsR
        _ -> do
            setMessageI MsgNewMemberError
            redirect $ NewTeacherGStudentR
