module Handler.TeacherUGStudent where

import Import
import UniversityMembersForms (teacherUGStudentForm)
import Employee (showRegime)

getTeacherUGStudentsR :: Handler Html
getTeacherUGStudentsR = do

    mmsg <- getMessage
    teacherUGStudents <- runDB $ selectList [] [Asc TeacherUGStudentId]
    defaultLayout $ do
        setTitle "TeacherUGStudents"
        $(widgetFile "teacherUGStudent/all")


getNewTeacherUGStudentR :: Handler Html
getNewTeacherUGStudentR = do

    mmsg <- getMessage

    let memberType = "TeacherUGStudents" :: Text
        route = TeacherUGStudentsR

    (formWidget, enctype) <- generateFormPost $ teacherUGStudentForm Nothing

    defaultLayout $ do
        setTitle "New TeacherUGStudent"
        $(widgetFile "member/new")    

postNewTeacherUGStudentR :: Handler ()
postNewTeacherUGStudentR = do

    ((res, _), _) <- runFormPost $ teacherUGStudentForm Nothing

    case res of
        FormSuccess newTUGS -> do
            mid <- runDB $ getBy $ UniqueTUGSReg (teacherUGStudentRegE newTUGS) (teacherUGStudentRegS newTUGS)
            case mid of
                Nothing -> do
                    _ <- runDB $ insert newTUGS
                    setMessageI MsgMemberSaved
                    redirect $ TeacherUGStudentsR
                _ -> do
                    setMessageI MsgDuplicatedMemberError
                    redirect $ NewTeacherUGStudentR
        _ -> do
            setMessageI MsgNewMemberError
            redirect $ NewTeacherUGStudentR

getEditTeacherUGStudentR :: TeacherUGStudentId -> Handler Html
getEditTeacherUGStudentR tsid = do
    (mmsg) <- getMessage

    let memberType = "TeacherUGStudents" :: Text
        route = TeacherUGStudentsR

    -- get the teacherUGStudent by id
    teacherUGStudent <- runDB $ selectFirst [TeacherUGStudentId ==. tsid] []

    (formWidget, enctype) <- generateFormPost $ teacherUGStudentForm $ fmap entityVal teacherUGStudent

    defaultLayout $ do
        setTitle "Edit TeacherUGStudent"
        $(widgetFile "member/edit")

postEditTeacherUGStudentR :: TeacherUGStudentId -> Handler ()
postEditTeacherUGStudentR tsid = do
    -- get the teacherUGStudent by id
    teacherUGStudent <- runDB $ get404 tsid

    ((res,_), _) <- runFormPost $ teacherUGStudentForm $ Just teacherUGStudent

    case res of

        FormSuccess updateTUGS -> do

            mdup <- runDB $ getBy $ UniqueTUGSReg (teacherUGStudentRegE updateTUGS) (teacherUGStudentRegS updateTUGS)
            case fmap entityKey mdup of
                Just _ -> do
                    setMessageI MsgDuplicatedMemberError
                    redirect $ EditTeacherUGStudentR tsid
                Nothing -> do
                    _ <- runDB $ replace tsid $ updateTUGS
                    setMessageI MsgMemberSaved
            redirect $ TeacherUGStudentsR
        _ -> do
            setMessageI MsgNewMemberError
            redirect $ NewTeacherUGStudentR
