module Model where

import ClassyPrelude.Yesod
import Database.Persist.Quasi

import Person (Person (..), Genre (..))
import Employee (Employee (..), EmployeeTeacher (..), EmployeeServant (..), Regime (..), Outsourcing (..))
import Student (Student (..), UGStudent (..), GStudent (..))

-- You can define all of your database entities in the entities file.
-- You can find more information on persistent and how to declare entities
-- at:
-- http://www.yesodweb.com/book/persistent/
share [mkPersist sqlSettings, mkMigrate "migrateAll"]
    $(persistFileWith lowerCaseSettings "config/models")

-- the Person class implementation
instance Person Undergraduate where
    name = undergraduateName
    age = undergraduateAge
    genre = undergraduateGenre

-- the Student class implementation
instance Student Undergraduate where
    s_reg = undergraduateReg
    s_adm = undergraduateAdm
    s_course = undergraduateCourse
    s_gpa = undergraduateGpa

-- the Student class implementation
instance UGStudent Undergraduate where
    ugs_score = undergraduateScore
    

-- the Person class implementation
instance Person Graduate where
    name = graduateName
    age = graduateAge
    genre = graduateGenre

-- the Student class implementation
instance Student Graduate where
    s_reg = graduateReg
    s_adm = graduateAdm
    s_course =graduateCourse
    s_gpa = graduateGpa

-- the GStudent class implementation
instance GStudent Graduate where
    gs_grad = graduateGrad

-- the Person class implementation
instance Person Teacher where
    name = teacherName
    genre = teacherGenre
    age = teacherAge

-- the Employee class implementation
instance Employee Teacher where
    e_reg = teacherReg
    e_adm = teacherAdm
    salary = teacherSal

-- the EmployeeTeacher class implementation
instance EmployeeTeacher Teacher where
    t_regime = teacherRegime

-- the Person class implementation
instance Person TeacherUGStudent where
    name = teacherUGStudentName
    age = teacherUGStudentAge
    genre = teacherUGStudentGenre

-- the EmployeeTeacher class implementation
instance EmployeeTeacher TeacherUGStudent where
    t_regime = teacherUGStudentRegime

-- the Employee class implementation
instance Employee TeacherUGStudent where
    e_reg = teacherUGStudentRegE
    e_adm = teacherUGStudentAdmE
    salary = teacherUGStudentSal

-- the Student class implementation
instance Student TeacherUGStudent where
    s_reg = teacherUGStudentRegS
    s_adm = teacherUGStudentAdmS
    s_course =teacherUGStudentCourse
    s_gpa = teacherUGStudentGpa

-- the UGStudent class implementation
instance UGStudent TeacherUGStudent where
    ugs_score = teacherUGStudentScore

-- the Person class implementation
instance Person TeacherGStudent where
    name = teacherGStudentName
    age = teacherGStudentAge
    genre = teacherGStudentGenre

-- the Employee class implementation
instance Employee TeacherGStudent where
    e_reg = teacherGStudentRegE
    e_adm = teacherGStudentAdmE
    salary = teacherGStudentSal

-- the EmployeeTeacher class implementation
instance EmployeeTeacher TeacherGStudent where
    t_regime = teacherGStudentRegime

-- the Student class implementation
instance Student TeacherGStudent where
    s_reg = teacherGStudentRegS
    s_adm = teacherGStudentAdmS
    s_course =teacherGStudentCourse
    s_gpa = teacherGStudentGpa

-- the GStudent class implementation
instance GStudent TeacherGStudent where
    gs_grad = teacherGStudentGrad

-- the Person class implementation
instance Person CivilServant where
    name = civilServantName
    age = civilServantAge
    genre = civilServantGenre

-- the Employee class implementation
instance Employee CivilServant where
    e_reg = civilServantReg
    e_adm = civilServantAdm
    salary = civilServantSal

-- the EmployeeServant class implementation
instance EmployeeServant CivilServant where
    e_outs = civilServantOuts

-- the Person class implementation
instance Person ServantUGStudent where
    name = servantUGStudentName
    age = servantUGStudentAge
    genre = servantUGStudentGenre

-- the Employee class implementation
instance Employee ServantUGStudent where
    e_reg = servantUGStudentRegE
    e_adm = servantUGStudentAdmE
    salary = servantUGStudentSal

-- the EmployeeServant class implementation
instance EmployeeServant ServantUGStudent where
    e_outs = servantUGStudentOuts

-- the Student class implementation
instance Student ServantUGStudent where
    s_reg = servantUGStudentRegS
    s_adm = servantUGStudentAdmS
    s_course = servantUGStudentCourse
    s_gpa = servantUGStudentGpa

-- the UGStudent class implementation
instance UGStudent ServantUGStudent where
    ugs_score = servantUGStudentScore

-- the Person class implementation
instance Person ServantGStudent where
    name = servantGStudentName
    age = servantGStudentAge
    genre = servantGStudentGenre

-- the Employee class implementation
instance Employee ServantGStudent where
    e_reg = servantGStudentRegE
    e_adm = servantGStudentAdmE
    salary = servantGStudentSal

-- the EmployeeServant class implementation
instance EmployeeServant ServantGStudent where
    e_outs = servantGStudentOuts

-- the Student class implementation
instance Student ServantGStudent where
    s_reg = servantGStudentRegS
    s_adm = servantGStudentAdmS
    s_course = servantGStudentCourse
    s_gpa = servantGStudentGpa

-- the GStudent class implementation
instance GStudent ServantGStudent where
    gs_grad = servantGStudentGrad

-- The UniversityMember Wrapper
data UniversityMember =
        UGSMember Undergraduate
    |   GSMember Graduate
    |   TMember Teacher
    |   TUGSMember TeacherUGStudent
    |   TGSMember TeacherGStudent
    |   CSMember CivilServant
    |   SUGSMember ServantUGStudent
    |   SGSMember ServantGStudent

    deriving (Show, Eq)

-- the Person class implementation           
instance Person UniversityMember where
    name um =
        case um of
            UGSMember m -> name m
            GSMember m -> name m
            TMember m -> name m
            TUGSMember m -> name m
            TGSMember m -> name m
            CSMember m -> name m
            SUGSMember m -> name m
            SGSMember m -> name m
    genre um =
        case um of
            UGSMember m -> genre m
            GSMember m  -> genre m
            TMember m -> genre m
            TUGSMember m -> genre m
            TGSMember m -> genre m
            CSMember m -> genre m
            SUGSMember m -> genre m
            SGSMember m ->  genre m
    age um =
        case um of
            UGSMember m -> age m
            GSMember m -> age m
            TMember m -> age m
            TUGSMember m -> age m
            TGSMember m -> age m
            CSMember m -> age m
            SUGSMember m -> age m
            SGSMember m -> age m

-- the Employee class implementation
instance Employee UniversityMember where
    e_reg um =
        case um of
            TMember m -> e_reg m
            TUGSMember m -> e_reg m
            TGSMember m -> e_reg m
            CSMember m -> e_reg m
            SUGSMember m -> e_reg m
            SGSMember m -> e_reg m
            _ -> 0
    e_adm um =
        case um of
            TMember m -> e_adm m
            TUGSMember m -> e_adm m
            TGSMember m -> e_adm m
            CSMember m -> e_adm m
            SUGSMember m -> e_adm m
            SGSMember m -> e_adm m
            _ -> error "Invalid user type"
    salary um =
        case um of
            TMember m -> salary m
            TUGSMember m -> salary m
            TGSMember m -> salary m
            CSMember m -> salary m
            SUGSMember m -> salary m
            SGSMember m -> salary m
            _ -> 0.00

-- the EmployeeTeacher class implementation
instance EmployeeTeacher UniversityMember where
    t_regime um =
        case um of
            TMember m -> teacherRegime m
            TUGSMember m -> teacherUGStudentRegime m
            TGSMember m -> teacherGStudentRegime m
            _ -> error "Invalid user type"

-- the EmployeeServant class implementation
instance EmployeeServant UniversityMember where
    e_outs um =
        case um of
            CSMember m -> civilServantOuts m
            SUGSMember m -> servantUGStudentOuts m
            SGSMember m -> servantGStudentOuts m
            _ -> F

-- the Student class implementation
instance Student UniversityMember where
    s_reg um =
        case um of
            UGSMember m -> s_reg m
            GSMember m -> s_reg m
            TUGSMember m -> s_reg m
            TGSMember m -> s_reg m
            SUGSMember m -> s_reg m
            SGSMember m -> s_reg m
            _ -> 0

    s_adm um =
        case um of
            UGSMember m -> s_adm m
            GSMember m -> s_adm m
            TUGSMember m -> s_adm m
            TGSMember m -> s_adm m
            SUGSMember m -> s_adm m
            SGSMember m -> s_adm m
            _ -> error "Invalid user type"

    s_course um =
        case um of
            UGSMember m -> s_course m
            GSMember m -> s_course m
            TUGSMember m -> s_course m
            TGSMember m -> s_course m
            SUGSMember m -> s_course m
            SGSMember m -> s_course m
            _ -> ""

    s_gpa um =
        case um of
            UGSMember m -> s_gpa m
            GSMember m -> s_gpa m
            TUGSMember m -> s_gpa m
            TGSMember m -> s_gpa m
            SUGSMember m -> s_gpa m
            SGSMember m -> s_gpa m
            _ -> 0.0

instance UGStudent UniversityMember where
    ugs_score um =
        case um of
            UGSMember m -> undergraduateScore m
            TUGSMember m -> teacherUGStudentScore m
            SUGSMember m -> servantUGStudentScore m
            _ -> 0

instance GStudent UniversityMember where
    gs_grad um =
        case um of
            GSMember m -> graduateGrad m
            TGSMember m -> teacherGStudentGrad m
            SGSMember m -> servantGStudentGrad m
            _ -> ""
