module Employee (Employee (..), EmployeeTeacher (..), EmployeeServant (..), Regime (..), Outsourcing (..), readMaybeRegime, readMaybeOutsourcing, showRegime) where

import ClassyPrelude.Yesod
import Text.Read (readMaybe)

data Regime = RED | R20 | R40 deriving (Read, Show, Eq)

data Outsourcing = V | F deriving (Read, Show, Eq)

showRegime :: Regime -> String
showRegime r =
    case r of
        RED -> "DE"
        R20 -> "20"
        R40 -> "40"

readMaybeRegime :: String -> Maybe Regime
readMaybeRegime s =
    case s of
        "DE" -> Just RED
        "20" -> Just R20
        "40" -> Just R40
        _ -> readMaybe s :: Maybe Regime

readMaybeOutsourcing :: String -> Maybe Outsourcing
readMaybeOutsourcing s = readMaybe s :: Maybe Outsourcing

class Employee employee where
    e_reg :: employee -> Int
    e_adm :: employee -> Day
    salary :: employee -> Double

class EmployeeTeacher employee where
    t_regime :: employee -> Regime

class EmployeeServant employee where
    e_outs :: employee -> Outsourcing

derivePersistField "Regime"
derivePersistField "Outsourcing"