module CivilServant (CivilServant (..), readMaybeCivilServant) where

import Lib (readMaybeInt, readMaybeInteger, readMaybeFloat)

import Date (Month (..), Date (..), readMaybeDate)
import Person (Genre (..), Person (..), readMaybeGenre)
import Employee (Employee (..), Outsourcing (..), readMaybeOutsourcing)


data CivilServant =
    CivilServant {
            cs_name :: String
        ,   cs_age :: Int
        ,   cs_genre :: Genre
        ,   cs_reg :: Integer
        ,   cs_adm :: Date
        ,   cs_salary :: Float
        ,   cs_outsourced :: Outsourcing

    } deriving (Show, Eq)

instance Person CivilServant where
    name = cs_name
    genre = cs_genre
    age = cs_age

instance Employee CivilServant where
    e_reg = cs_reg
    e_adm = cs_adm
    salary = cs_salary

readMaybeCivilServant :: [String] -> Maybe CivilServant
readMaybeCivilServant [csName, csAge, csGenre, csReg, csAdm, csSal, csOut] =
    case (readMaybeInt csAge, readMaybeGenre csGenre, readMaybeInteger csReg, readMaybeDate csAdm, readMaybeFloat csSal, readMaybeOutsourcing csOut) of
        (Just age', Just genre', Just reg', Just adm', Just sal', Just outsourcing') -> Just $ CivilServant csName age' genre' reg' adm' sal' outsourcing'
        _ -> Nothing

readMaybeCivilServant _ = Nothing