module Date (Month (..), Date (..), readMaybeMonth, readMaybeDate) where

-- import Lib (splitByChar)
import Text.Read (readMaybe)
import Lib (readMaybeInt)

data Month = Jan | Feb | Mar | Apr | May | Jun | Jul | Aug | Sep | Oct | Nov | Dec deriving (Show, Eq, Ord)

data Date =
    Date {
            day :: Int
        ,   month :: Month
        ,   year :: Int
    } deriving (Eq)


instance Show Date where
    show (Date d m y) = show d ++ " " ++ show m ++ " " ++ show y

instance Ord Date where
    a < b = year a < year b || year a == year b && month a < month b || year a == year b && month a == month b && day a < day b
    a <= b = year a < year b || year a == year b && month a < month b || year a == year b && month a == month b && day a <= day b

readMaybeMonth :: String -> Maybe Month
readMaybeMonth "" = Nothing
readMaybeMonth m
    | "1" == m || "01" == m || "Jan" == m = Just Jan
    | "2" == m || "02" == m || "Feb" == m = Just Feb
    | "3" == m || "03" == m || "Mar" == m = Just Mar
    | "4" == m || "04" == m || "Apr" == m = Just Apr
    | "5" == m || "05" == m || "May" == m = Just May
    | "6" == m || "06" == m || "Jun" == m = Just Jun
    | "7" == m || "07" == m || "Jul" == m = Just Jul
    | "8" == m || "08" == m || "Aug" == m = Just Aug
    | "9" == m || "09" == m || "Sep" == m = Just Sep
    | "10" == m || "Oct" == m = Just Oct
    | "11" == m || "Nov" == m = Just Nov
    | "12" == m || "Dec" == m = Just Dec
    | otherwise = Nothing

readMaybeDate :: String -> Maybe Date
readMaybeDate "" = Nothing
readMaybeDate date = 
    case (readMaybeInt d, readMaybeMonth m, readMaybeInt y) of
        (Just day', Just month', Just year') -> Just $ Date day' month' year'
        _ -> Nothing
    where
        ss = splitByChar '/' date ""
        (d, m, y) = 
            if 3 == length ss
                then
                    (ss!!0, ss!!1, ss!!2)
                else
                    ("", "", "")

splitByChar :: Char -> String -> String -> [String]
splitByChar _ "" tmp = [tmp]
splitByChar c (s:ss) tmp =
    if s == c
        then
            tmp : splitByChar c ss ""
        else
            splitByChar c ss (tmp ++ [s])
