module Employee (Employee (..), Regime (..), Outsourcing (..), readMaybeRegime, readMaybeOutsourcing) where

import Text.Read (readMaybe)

import Date (Date (..))

data Regime = RED | R20 | R40 deriving (Read, Eq)

data Outsourcing = V | F deriving (Read, Show, Eq)

instance Show Regime where
    show r =
        case r of
            RED -> "DE"
            R20 -> "20"
            R40 -> "40"

readMaybeRegime :: String -> Maybe Regime
readMaybeRegime s =
    case s of
        "DE" -> Just RED
        "20" -> Just R20
        "40" -> Just R40
        _ -> readMaybe s :: Maybe Regime

readMaybeOutsourcing :: String -> Maybe Outsourcing
readMaybeOutsourcing s = readMaybe s :: Maybe Outsourcing

class Employee employee where
    e_reg :: employee -> Integer
    e_adm :: employee -> Date
    salary :: employee -> Float
