module GStudent (GStudent (..), readMaybeGStudent) where

import Lib (readMaybeInt, readMaybeInteger, readMaybeFloat)

import Date (Month (..), Date (..), readMaybeDate)
import Person (Genre (..), Person (..), readMaybeGenre)
import Student (Student (..))

data GStudent =
    GStudent {
            gs_name :: String
        ,   gs_age :: Int
        ,   gs_genre :: Genre
        ,   gs_reg :: Integer
        ,   gs_adm :: Date
        ,   gs_course :: String
        ,   gs_gpa :: Float
        ,   gs_grad :: String

} deriving (Show, Eq)

-- the Person class implementation
instance Person GStudent where
    name = gs_name
    age = gs_age
    genre = gs_genre

-- the Student class implementation
instance Student GStudent where
    s_reg = gs_reg
    s_adm = gs_adm
    course = gs_course
    gpa = gs_gpa

readMaybeGStudent :: [String] -> Maybe GStudent
readMaybeGStudent [sName, sAge, sGenre, sReg, sAdm, sCourse, sGpa, grad'] =
    case (readMaybeInt sAge, readMaybeGenre sGenre, readMaybeInteger sReg, readMaybeDate sAdm, readMaybeFloat sGpa) of
        (Just age', Just genre', Just reg', Just adm', Just gpa') -> Just $ GStudent sName age' genre' reg' adm' sCourse gpa' grad'
        _ -> Nothing
readMaybeGStudent _ = Nothing