module Lib
    (   
            readMaybeInt
        ,   readMaybeInteger
        ,   readMaybeFloat
        ,   splitStrings
    ) where

import Text.Read (readMaybe)

-- convert String to Maybe Int
readMaybeInt :: String -> Maybe Int
readMaybeInt s = readMaybe s :: Maybe Int

-- convert String to Maybe Integer
readMaybeInteger :: String -> Maybe Integer
readMaybeInteger s = readMaybe s :: Maybe Integer

-- convert String to Maybe Float
readMaybeFloat :: String -> Maybe Float
readMaybeFloat s = readMaybe s :: Maybe Float   

-- split strings
splitStrings :: [String] -> [String] -> [[String]]
splitStrings [] [] = []
splitStrings [] tmp = [tmp]
splitStrings (l:ls) tmp =
    if length l < 1
        then
            tmp : splitStrings ls []
        else
            splitStrings ls (tmp ++ [l])