module Teacher (Teacher (..), readMaybeTeacher) where

import Lib (readMaybeInt, readMaybeInteger, readMaybeFloat)

import Date (Month (..), Date (..), readMaybeDate)
import Person (Person (..), Genre (..), readMaybeGenre)
import Employee (Employee (..), Regime (..), readMaybeRegime)


data Teacher =
    Teacher {
                t_name :: String
            ,   t_age :: Int
            ,   t_genre :: Genre
            ,   t_reg :: Integer
            ,   t_adm :: Date
            ,   t_salary :: Float
            ,   t_regime :: Regime

            } deriving (Show, Eq)

-- the Person class implementation
instance Person Teacher where
    name = t_name
    age = t_age
    genre = t_genre

-- the Student class implementation
instance Employee Teacher where
    e_reg = t_reg
    e_adm = t_adm
    salary = t_salary

readMaybeTeacher :: [String] -> Maybe Teacher
readMaybeTeacher [tName, tAge, tGenre, tReg, tAdm, tSal, tRegime] =
    case (readMaybeInt tAge, readMaybeGenre tGenre, readMaybeInteger tReg, readMaybeDate tAdm, readMaybeFloat tSal, readMaybeRegime tRegime) of
        (Just age', Just genre', Just reg', Just adm', Just sal', Just regime') -> Just $ Teacher tName age' genre' reg' adm' sal' regime'
        _ -> Nothing
readMaybeTeacher _ = Nothing
