module UGStudent (UGStudent (..), readMaybeUGStudent) where

import Lib (readMaybeInt, readMaybeInteger, readMaybeFloat)

import Date (Month (..), Date (..), readMaybeDate)
import Person (Genre (..), Person (..), readMaybeGenre)
import Student (Student (..))

data UGStudent =
    UGStudent {
            ugs_name :: String
        ,   ugs_age :: Int
        ,   ugs_genre :: Genre
        ,   ugs_reg :: Integer
        ,   ugs_adm :: Date
        ,   ugs_course :: String
        ,   ugs_gpa :: Float
        ,   ugs_score :: Int
    } deriving (Show, Eq)

-- the Person class implementation
instance Person UGStudent where
    name = ugs_name
    genre = ugs_genre
    age = ugs_age

-- the Student class implementation
instance Student UGStudent where
    s_reg = ugs_reg
    s_adm = ugs_adm
    course = ugs_course
    gpa = ugs_gpa

readMaybeUGStudent :: [String] -> Maybe UGStudent
readMaybeUGStudent [sName, sAge, sGenre, sReg, sAdm, sCourse, sGpa, sScore] =
    case (readMaybeInt sAge, readMaybeGenre sGenre, readMaybeInteger sReg, readMaybeDate sAdm, readMaybeFloat sGpa, readMaybeInt sScore) of
        (Just age', Just genre', Just reg', Just adm', Just gpa', Just score') -> Just $ UGStudent sName age' genre' reg' adm' sCourse gpa' score'
        _ -> Nothing
readMaybeUGStudent _ = Nothing